//+------------------------------------------------------------------+
//|                                           Volatily_co_volume.mq4 |
//|                               Copyright  2011, Nikolaj Ostapujk |
//|                                                  nikost@inbox.lv |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Nikolaj Ostapujk"
#property link      "nikost@inbox.lv"
//#property indicator_minimum 0.35
//#property indicator_maximum 0.65
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Sienna
#property indicator_color3 Magenta 
#property indicator_level1 1.0
#property indicator_level2 1.2
#property indicator_level3 0.8
//-----
extern int fast = 5;
extern int midi = 14;
//-----
double hstP[];
double hstV[];
double HSTP[];
double HSTV[];
double PV[];
//+------------ ------------------------------------------------------+
int init()
 {
   IndicatorBuffers(5);
   SetIndexBuffer(0, HSTP);
   SetIndexBuffer(1, HSTV);
   SetIndexBuffer(2, PV);
   SetIndexBuffer(3, hstP);
   SetIndexBuffer(4, hstV);
   //-----
   SetIndexStyle(0, DRAW_LINE);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexStyle(2, DRAW_LINE,2);
   //-----
   return(0);
 }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()
 {
   int counted_bars = IndicatorCounted();
   int i, limit;
//----
   if(counted_bars == 0) 
       limit = Bars - midi - 1;
   if(counted_bars > 0)  
       limit = Bars - counted_bars;
   for(i = limit; i >= 0; i--)
    {
      hstP[i] = hrst(fast,i)/hrst(midi,i);
      hstV[i] = hrst1(fast,i)/hrst1(midi,i);
    } 
  i = Bars - counted_bars-1; 
   while(i > 0)
    {
     HSTP[i]=iMAOnArray(hstP,Bars,fast,0,MODE_SMA,i);
     HSTV[i]=iMAOnArray(hstV,Bars,fast,0,MODE_SMA,i);
     PV[i]=hstP[i]/hstV[i];
     i--;
   }
   //-----
   return(0);
 }
//+------------------------------------------------------------------+

double hrst(int slow,int i)
{
   double nv = 0.0;
   for (int j = i; j < (i+slow); j++) nv = nv + MathAbs(Close[j]-Open[j])/Point;
   nv = nv / slow;
   return (nv);
}
double hl(int slow,int i)
{
   double nv = 0.0;
   for (int j = i; j < (i+slow); j++) nv = nv + (High[j]-Low[j])/Point;
   nv = nv / slow;
   return (nv);
}

double hrst1(int slow,int i)
{
   double nv = 0.0;
   for (int j = i; j < (i+slow); j++) nv = nv + Volume[j];
   nv = nv / slow;
   return (nv);
}